//+------------------------------------------------------------------+
//|hmacd .mq4 
//| 
//+------------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Aqua
#property indicator_color2     Magenta
#property indicator_color3     LightSeaGreen
#property indicator_color4     LightSeaGreen
#property indicator_level1     0
#property indicator_levelcolor Gold

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    FastMa           = 12;
extern int    FastMaMetod      = 3;
extern int    SlowMa           = 26;
extern int    SlowMaMetod      = 3;
extern int    Step             = 0;
extern bool   UseT3Macd        = true;
extern int    FastT3Period     = 24;
extern double FastT3Hot        = 1.0;
extern bool   FastT3Original   = false;
extern bool   FastT3Adaptive   = true;
extern int    SlowT3Period     = 52;
extern double SlowT3Hot        = 1.0;
extern bool   SlowT3Original   = false;
extern bool   SlowT3Adaptive   = true;
extern int    BandsPeriod      = 20;
extern double BandsDeviation   = 2;
extern string BarsID           = "Hamacd1";
extern bool   Interpolate      = true;

extern color  ColorUp          = RoyalBlue;
extern color  ColorDn          = Red;
extern int    widthWick        = 1;
extern int    widthBody        = 2;
extern bool   ShowArrows       = false;

extern string _                = "Alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double haUp[];
double haDn[];
double UpArrow[];
double DnArrow[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];


//
//
//
//
//

string shortName;
string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;
int    window;

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,UpArrow); 
   SetIndexBuffer(1,DnArrow);
   SetIndexBuffer(2,haUp); 
   SetIndexBuffer(3,haDn);  
   SetIndexBuffer(4,Buffer1); 
   SetIndexBuffer(5,Buffer2); 
   SetIndexBuffer(6,Buffer3); 
   SetIndexBuffer(7,Buffer4); 
   
   
   if (ShowArrows)
   {
      SetIndexStyle(0,DRAW_ARROW);  SetIndexArrow(0,233);     
      SetIndexStyle(1,DRAW_ARROW);  SetIndexArrow(1,234);     
   }
   else
   {
      SetIndexStyle(0,DRAW_NONE);       
      SetIndexStyle(1,DRAW_NONE);       
   }


   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   calculateValue    = (TimeFrame=="calculateValue"); 
   if (calculateValue)
   {
         int s = StringFind(BarsID,":",0);
               shortName = BarsID;
               BarsID = StringSubstr(BarsID,0,s);
               return(0);
    } 
    timeFrame = stringToTimeFrame(TimeFrame);           
      
   //
   //
   //
   //
   //

   shortName = BarsID+": "+timeFrameToString(timeFrame)+ "  heiken ashi macd";
   IndicatorShortName(shortName);
return(0);
}

//
//
//
//
//

int deinit()
{
   int lookForLength = StringLen(BarsID);
   
   for (int i=ObjectsTotal()-1; i>=0; i--) {
   
   string objectName = ObjectName(i);
   if (StringSubstr(objectName,0,lookForLength) == BarsID) ObjectDelete(objectName);
   }
    
   return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    pointModifier;
   int    pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { UpArrow[0] = limit+1; return(0); }
         window = WindowFind(shortName);
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {          
   
   if (Digits==3 || Digits==5)
         pointModifier = 10;
   else  pointModifier = 1; 
               
   //
   //
   //
   //
   //
   
   for(pos = limit; pos >= 0; pos--)
   {
      if (UseT3Macd)
         {
            double macdOpen  = iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN ,pos),FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,pos,0)-
                               iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN ,pos),SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,pos,1);  
            double macdClose = iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,pos),FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,pos,2)-
                               iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,pos),SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,pos,3);  
            double macdLow   = iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW  ,pos),FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,pos,4)-
                               iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW  ,pos),SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,pos,5);  
            double macdHigh  = iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH ,pos),FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,pos,6)-
                               iT3a(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH ,pos),SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,pos,7);  
         }
      else
         {
            macdOpen  = iMA(NULL,0,FastMa,0,FastMaMetod,PRICE_OPEN ,pos) - iMA(NULL,0,SlowMa,0,SlowMaMetod,PRICE_OPEN  ,pos);
            macdClose = iMA(NULL,0,FastMa,0,FastMaMetod,PRICE_CLOSE,pos) - iMA(NULL,0,SlowMa,0,SlowMaMetod,PRICE_CLOSE ,pos);
            macdLow   = iMA(NULL,0,FastMa,0,FastMaMetod,PRICE_LOW  ,pos) - iMA(NULL,0,SlowMa,0,SlowMaMetod,PRICE_LOW   ,pos);
            macdHigh  = iMA(NULL,0,FastMa,0,FastMaMetod,PRICE_HIGH ,pos) - iMA(NULL,0,SlowMa,0,SlowMaMetod,PRICE_HIGH  ,pos);
         }
   
      //
      //
      //
      //
      //
        
         
           double haClose = (macdOpen + macdHigh + macdLow + macdClose)/4;
           double haOpen  = (Buffer3[pos+1]  + Buffer4[pos+1])/2;
           double haHigh  = MathMax(macdHigh, MathMax(haOpen,haClose));
           double haLow   = MathMin(macdLow,  MathMin(haOpen,haClose));
           double stdev   = iStdDev(NULL,0,BandsPeriod,0,MODE_SMA,PRICE_CLOSE,pos);
               haUp[pos]  = haClose + BandsDeviation * stdev;
               haDn[pos]  = haClose - BandsDeviation * stdev;

      if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
      else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                            Buffer3[pos]=haOpen;
                            Buffer4[pos]=haClose;
      
      //
      //
      //
      //
      //

      if (Step > 0)
      {
         if( MathAbs(Buffer1[pos]-Buffer1[pos+1]) < Step*pointModifier*Point ) Buffer1[pos]=Buffer1[pos+1];
         if( MathAbs(Buffer2[pos]-Buffer2[pos+1]) < Step*pointModifier*Point ) Buffer2[pos]=Buffer2[pos+1];
         if( MathAbs(Buffer3[pos]-Buffer3[pos+1]) < Step*pointModifier*Point ) Buffer3[pos]=Buffer3[pos+1];
         if( MathAbs(Buffer4[pos]-Buffer4[pos+1]) < Step*pointModifier*Point ) Buffer4[pos]=Buffer4[pos+1];
      }
            
      if (!calculateValue) drawBar(Time[pos],Buffer1[pos],Buffer2[pos],Buffer3[pos],Buffer4[pos]);
      
      UpArrow[pos] = EMPTY_VALUE;
      DnArrow[pos] = EMPTY_VALUE;  
        
      if (Buffer3[pos] < Buffer4[pos] && Buffer4[pos+1] < Buffer3[pos+1]) UpArrow[pos] = Buffer4[pos+1] - (Ask-Bid);  
      if (Buffer3[pos] > Buffer4[pos] && Buffer4[pos+1] > Buffer3[pos+1]) DnArrow[pos] = Buffer4[pos+1] + (Ask-Bid); 
      
    }
     
    manageAlerts();
    return(0);
    }
    
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(pos = limit; pos >= 0; pos--)
   {
   
     int y = iBarShift(NULL,timeFrame,Time[pos]);
       haUp[pos]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,2,y);
       haDn[pos]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,3,y);
       Buffer1[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,4,y);
       Buffer2[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,5,y);
       Buffer3[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,6,y);
       Buffer4[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,7,y);
       drawBar(Time[pos],Buffer1[pos],Buffer2[pos],Buffer3[pos],Buffer4[pos]); 
            if (y!=iBarShift(NULL,timeFrame,Time[pos+1]))
            {
               UpArrow[pos] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,0,y);
               DnArrow[pos] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",FastMa,FastMaMetod,SlowMa,SlowMaMetod,Step,UseT3Macd,FastT3Period,FastT3Hot,FastT3Original,FastT3Adaptive,SlowT3Period,SlowT3Hot,SlowT3Original,SlowT3Adaptive,BandsPeriod,BandsDeviation,BarsID,1,y);
            }

      //
      //
      //
      //
      //
      
      if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[pos-1])) continue;
      
      //
      //
      //
      //
      //

      datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; pos+n < Bars && Time[pos+n] >= time; n++) continue;	
         for(int k = 1; k < n; k++)
         {
            haUp[pos+k] = haUp[pos] + (haUp[pos+n] - haUp[pos]) * k/n;
            haDn[pos+k] = haDn[pos] + (haDn[pos+n] - haDn[pos]) * k/n;
         }                  
   }
   
   
      
   manageAlerts();
   return(0);
}
   

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      if (UpArrow[whichBar]!= EMPTY_VALUE) doAlert(whichBar,"HAmacd buy");   
      if (DnArrow[whichBar]!= EMPTY_VALUE) doAlert(whichBar,"HAmacd sell"); 
      
      }
   }
   
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Heiken Ashi ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][56];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5
#define _atr    6

//
//
//
//
//

double iT3a(double price, double period, double hot, bool original, bool adaptive, int i, int forInstance=0)
{
   int r      = Bars-i-1;
   int buffer = forInstance*7;

   //
   //
   //
   //
   //
   
      if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
      if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);
      if (adaptive)
      {
         workT3[r][_atr+buffer] = iATR(NULL,0,period,i);
            double max = workT3[r][_atr+buffer];
            double min = workT3[r][_atr+buffer];
            for (int k=1; k<period && (r-k>=0); k++)
               {
                  max = MathMax(max,workT3[r-k][_atr+buffer]);
                  min = MathMin(min,workT3[r-k][_atr+buffer]);
               }
            if (min!=max)
                  double atn = 1.0-(workT3[r][_atr+buffer]-min)/(max-min);
            else         atn = 0.5;
            period = period*(atn+1.0)/2.0;
      }
   
   //
   //
   //
   //
   //
   
      if (workT3Coeffs[forInstance][_period] != period)
      {
        workT3Coeffs[forInstance][_period] = period;
           double a = hot;
               workT3Coeffs[forInstance][_c1] = -a*a*a;
               workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
               workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
               workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
               if (original)
                    workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
               else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
      }
   
   //
   //
   //
   //
   //
   
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void drawBar(int bTime, double prHigh, double prLow, double prOpen, double prClose)
{
   color wickColor = ColorUp; if (prHigh >prLow)  wickColor = ColorDn;
   color barColor  = ColorUp; if (prClose<prOpen) barColor  = ColorDn;
   string oName    = BarsID+":"+TimeToStr(bTime)+"w";
          
            if (ObjectFind(oName) == -1)
              ObjectCreate(oName, OBJ_TREND,window,bTime,0,bTime,0);
                 ObjectSet(oName, OBJPROP_PRICE1, prHigh);
                 ObjectSet(oName, OBJPROP_PRICE2, prLow);
                 ObjectSet(oName, OBJPROP_COLOR, wickColor);
                 ObjectSet(oName, OBJPROP_WIDTH, widthWick);
                 ObjectSet(oName, OBJPROP_RAY, false);
                 ObjectSet(oName, OBJPROP_BACK, true);
           
         oName = BarsID+":"+TimeToStr(bTime)+"b";
            if (ObjectFind(oName) ==  -1)
              ObjectCreate(oName, OBJ_TREND,window,bTime,0,bTime,0);
                 ObjectSet(oName, OBJPROP_PRICE1, prOpen);
                 ObjectSet(oName, OBJPROP_PRICE2, prClose);
                 ObjectSet(oName, OBJPROP_COLOR, barColor);
                 ObjectSet(oName, OBJPROP_WIDTH, widthBody);
                 ObjectSet(oName, OBJPROP_RAY, false);
                 ObjectSet(oName, OBJPROP_BACK, true);
}

